version: "3.8"

x-envs: &envs
  "ENVIRONMENT": "PRODUCTION"
  "TIME_ZONE": "America/Sao_Paulo"
  "DJANGO_SETTINGS_MODULE": "settings.production"
  "POSTGRES_DB": "postgres"
  "POSTGRES_USER": "postgres"
  "POSTGRES_PASSWORD": "Worc2021!."

services:
  service-postgres:
    image: postgres
    container_name: db-postgres
    restart: always
    networks:
      - production-apps
    environment:
      <<: *envs
    volumes:
      - postgres_data:/var/lib/postgresql/data/
    deploy:
      placement:
        constraints:
          - "node.role==worker"

  service-candidates:
    build:
      dockerfile: ../../deploy/images/Dockerfile
      context: .
    image: image-candidates:latest
    container_name: api-candidates
    depends_on:
      - service-postgres
    ports:
      - "8000:8000"
    networks:
      - production-apps
    environment:
      <<: *envs
    deploy:
      placement:
        constraints:
          - "node.role==worker"
      update_config:
        parallelism: 1
        delay: 10s
        order: start-first
        monitor: 10s

      resources:
        limits:
          cpus: "0.25"

volumes:
  postgres_data:

networks:
  production-apps:
    driver: bridge